function HideAndShowFields(){
    var $field_type = $("#field-field_type").val();
    $("#field-text_length").hide();
    $("label[for='field-text_length']").hide();

    $(".field-options").hide();
    $("label[for='field-options']").hide();

    $(".field-value_checked").hide();
    $("label[for='field-value_checked']").hide();

    $(".field-value_unchecked").hide();
    $("label[for='field-value_unchecked']").hide();

    switch ($field_type) {
        case 'text':
        case 'textarea':
            $("#field-text_length").show();
            $("label[for='field-text_length']").show();
            break;

        case 'select':
        case 'radio':
            $(".field-options").show();
            $("label[for='field-options']").show();
            break;

        case 'checkbox':
            $(".field-value_checked").show();
            $("label[for='field-value_checked']").show();

            $(".field-value_unchecked").show();
            $("label[for='field-value_unchecked']").show();
            break;
    }
}
$(document).ready(function(){

    $('form[name=form-forms_control-standard] .radio-list div').removeClass('col-xs-12');
    $('form[name=form-forms_control-standard] .radio-list div').addClass('col-xs-4');

    HideAndShowFields();
    $('form[name=form-customfield]').submit(function() {
        var errors = [];
        if ($.trim($('#field-field_name').val()) == '') {
            errors.push({
                field: '#field-field_name',
                message: trans.form_fields.name_required
            });
        }

        if ($.trim($('#field-field_caption').val()) == '') {
            errors.push({
                field: '#field-field_caption',
                message: trans.form_fields.caption_required
            });
        }

        var $field_type = $("#field-field_type").val();

        switch ($field_type) {
            case 'text':
            case 'textarea':
                var i_val = parseInt($.trim($('#field-text_length').val()));

                if ($.trim($('#field-text_length').val()) == '') {
                    errors.push({
                        field: '#field-text_length',
                        message: 'Please enter text length'
                    });
                }
                else if (i_val <= 0) {
                    errors.push({
                        field: '#field-text_length',
                        message: 'Text length must be greater than zero'
                    });
                }
                break;

            case 'select':
            case 'radio':
                if ($.trim($(".field-options").val()) == '') {
                    errors.push({
                        field: '.field-options',
                        message: 'Please enter field options'
                    });
                }
                break;

            case 'checkbox':
                if ($.trim($('#field-value_checked').val()) == '') {
                    errors.push({
                        field: '#field-value_checked',
                        message: 'Please enter checked value'
                    });
                }

                if ($.trim($('#field-value_unchecked').val()) == '') {
                    errors.push({
                        field: '#field-value_unchecked',
                        message: 'Please enter unchecked value'
                    });
                }
                break;
        }

        AdminForm.displayErrors(errors);
        return errors.length == 0;
    });

    $("#field-field_type").change(function(){
        HideAndShowFields();
    });
});

$('[data-action="action-customfields-delete"]').click(function(){

    var deleteMode = $('input[name="form-customfields-delete-mode"]:checked').val();

    if (deleteMode == 'selected')
    {
        var ids = '';
        $('.checkbox-customfield:checked').each(function(){
            var id = $(this).val();
            ids += (ids == '' ? '' : ',') + id;
        });
        if (ids != '')
        {
            window.location='admin.php?p=forms_control&mode=deletecustomfield&deleteMode=selected&ids=' + ids + '&nonce=' +  $(this).attr('nonce');
        }
        else
        {
            alert('Please select at least one custom field to delete');
        }
    }
    else if (deleteMode == 'all')
    {
        window.location='admin.php?p=forms_control&mode=deletecustomfield&deleteMode=all' + '&nonce=' + $(this).attr('nonce');
    }
});


function removeCustomField(id, nonce) {
    AdminForm.confirm('Are you sure you wish to remove this custom field?', function() {
        window.location = 'admin.php?p=forms_control&mode=deletecustomfield&deleteMode=single&id=' + id + '&nonce=' + nonce;
    });

    return false;
}

function pushAddCUstomFieldButton(url){
    window.location=url;
}