var forms = (function() {
	var init, initAddressForm, ensureTooltips, initCheckbox, getPasswordStrength, setPasswordMeter;

	init = function() {
		$('body').on('load', '.field-checkbox', function() {
			initCheckbox(this);
		});

		$(document).ready(function() {
			var collapsePanels = $('fieldset .collapse');
			collapsePanels.on('show.bs.collapse', function() {
				$(this).closest('fieldset').addClass('open')
					.find('button[data-toggle=collapse]').html('Close<span class="caret"></span>');
			});
			collapsePanels.on('hide.bs.collapse', function() {
				$(this).closest('fieldset').removeClass('open')
					.find('button[data-toggle=collapse]').html('Edit<span class="caret"></span>');
			});

			$('fieldset').has('.collapse').find('legend').click(function() {
				$(this).parent('fieldset').find('button[data-toggle=collapse]').click();
			}).css('cursor', 'pointer');

			$('form').each(function(idx, ele) {
				$($(ele).find('fieldset').get(0)).addClass('fieldset-primary');
			});

			$('.field-checkbox').each(function(idx, ele) {
				initCheckbox(ele);
			});

			ensureTooltips();

			/**
			 * Multiple image fields
			 */
			$('.field-image-multiple .button-file-add')
				.data('counter', 1)
				.click(function() {
				var addButton = this;
				var parent =  $(this).closest('.field-image-multiple');
				var inputFieldName = $(this).attr('data-field-name');
				var fileInput = $(parent).find('input.clean[type="file"]');

				if (fileInput.length == 0) {
					var counter = $(addButton).data('counter');
					fileInput = $('<input type="file" class="clean ' + inputFieldName + '-' + counter + '-file " name="' + inputFieldName +'[]">').appendTo(parent);
					$(addButton).data('counter', counter+1);

					/**
					 * Handle file change
					 */
					$(fileInput).change(function(){
						var self = this;
						if (self.files != undefined && self.files[0]) {
							var file = this.files[0];

							if (!file || file.name == undefined || file.size == undefined) return;

							var type = '|' + file.type.slice(file.type.lastIndexOf('/') + 1) + '|';

							if ('|jpg|png|jpeg|gif|'.indexOf(type) === -1) {
								alert('Please choose image file!');
								return;
							}

							$(self).removeClass('clean');

							var imageUploadPreview = $(
								'<div class="field-image-multiple-preview ' + inputFieldName + '-' + counter + '-preview">' +
									'<canvas></canvas>' +
									'<div><a href="#" class="btn" data-action="field-image-multiple-delete" data-role="button" data-target="' + inputFieldName + '-' + counter +'">Delete</a></div>' +
									'</div>'
							).insertBefore(addButton);

							var imageUploadPreviewCanvas = $(imageUploadPreview).find('canvas');
							var imageUploadPreviewDelete = $(imageUploadPreview).find('[data-action="field-image-multiple-delete"]');

							$(imageUploadPreviewDelete).click(function(){
								var deleteButton = this;
								AdminForm.confirm('Do you really want to delete selected image?', function() {
									var target = $(deleteButton).attr('data-target');
									$('.' + target + '-preview,.' + target + '-file').remove();
									AdminForm.displayAlert('Image has been successfully deleted', 'success');
								});
								return false;
							});

							var reader = new FileReader();

							reader.onload = function(e) {
								var data = e.target.result;
								var dataParts = data.split(',');

								var img = new Image();
								img.onload = function() {
									var width = this.width / (this.height / 150);
									var height = 150; // always 100 pixels
									imageUploadPreviewCanvas.attr({ width: width, height: height });
									imageUploadPreviewCanvas[0].getContext('2d').drawImage(this, 0, 0, width, height);
								};
								img.src = e.target.result;
							};
							reader.readAsDataURL(file);
						}
					});
				}

				$(fileInput).click();
			});

			// TODO: make image lists sortable, attache priority update
//		$('.field-image-multiple ul').sortable();
//		$('.field-image-multiple ul').disableSelection();

			$('.field-image-multiple a[data-action="field-image-multiple-preview"]').click(function(){
				var self = this;
				AdminForm.imagePreview($(self).attr('href'));
				return false;
			});

			$('.field-image-multiple a[data-action="field-image-multiple-edit"]').click(function(){
				var self = this;
				var imageEditModal = $('#modal-field-image-multiple-edit');

				var parent = $(self).closest('.field-image-multiple-preview');
				var src= $(parent).find('a[data-action="field-image-multiple-preview"] img').attr('src');
				var primary = $(self).attr('data-image-primary') == '1';
				var location = $(self).attr('data-image-location');

				imageEditModal.find('img.image-preview').attr('src', src);
				imageEditModal.find('.image-info').html(
					'Image file: ' + src + '<br>' +
					'Image location: ' + location + '<br>' +
					(
						$(self).attr('data-image-size') != 'x' && $(self).attr('data-image-file-size') != '' ?
						('Image size: ' + $(self).attr('data-image-size') + ' / ' + Math.round($(self).attr('data-image-file-size')/1024, 2) + 'kb') : ''
					) +
					(primary ? '<br><br><strong>This is primary product image</strong>' : '')
				);
				$(imageEditModal).find('.modal-field-image-multiple-edit-caption,.modal-field-image-multiple-edit-priority,.modal-field-image-multiple-edit-primary').toggle(!primary);

				$('#modal-field-image-multiple-edit-image-url').val($(self).attr('data-image-image-url'));
				$('#modal-field-image-multiple-edit-alt-text').val($(self).attr('data-image-alt-text'));
				$('#modal-field-image-multiple-edit-caption').val($(self).attr('data-image-caption'));
				$('#modal-field-image-multiple-edit-priority').val($(self).attr('data-image-priority'));
				$('#modal-field-image-multiple-edit-primary').prop('checked', false).removeAttr('checked').change();

				imageEditModal.find('.btn-primary').unbind('click').click(function(){

					var newAltText = $('#modal-field-image-multiple-edit-alt-text').val();
					var newCaption = $('#modal-field-image-multiple-edit-caption').val();
					var newPriority = $('#modal-field-image-multiple-edit-priority').val();
					var makePrimary = $('#modal-field-image-multiple-edit-primary').is(':checked');

					imageEditModal.modal('hide');

					AdminForm.sendRequest(
						$(self).attr('href'),
						{
							altText: newAltText,
							caption: newCaption,
							priority: newPriority,
							makePrimary: makePrimary ? '1' : '0'
						},
						'',
						function(result) {
							$(self).attr('data-image-alt-text', newAltText);
							$(self).attr('data-image-caption', newCaption);
							$(self).attr('data-image-priority', newPriority);

							var imageId = $(self).attr('data-image-id');

							// TODO: if set as primary, swap images here
							// mark current primary image
							var currentPrimary = $(self).closest('.field-image-multiple').find('.field-image-multiple-preview-primary');

							var currentSecondary = $(self).closest('.field-image-multiple').find('.field-image-multiple-preview-' + imageId);

							$(currentSecondary).find('a[data-action="field-image-multiple-preview"]').attr('href', result.primaryImage.imageFileName);
							$(currentSecondary).find('a[data-action="field-image-multiple-edit"]')
								.attr('data-image-id', 'primary')
								.attr('data-image-primary', '1')
								.attr('data-image-url', result.primaryImage.imageFileName)
								.attr('data-image-alt-text', result.primaryImage.altText)
								.attr('data-image-caption', '')
								.attr('data-image-priority', '0');

							var secondaryEditHref = $(currentSecondary).find('a[data-action="field-image-multiple-edit"]').attr('href');
							var _secondaryEditHref = secondaryEditHref;
							var secondaryDeleteHref = $(currentSecondary).find('a[data-action="field-image-multiple-delete"]').attr('href');
							var _secondaryDeleteHref = secondaryDeleteHref;

							$(currentSecondary).find('a[data-action="field-image-multiple-edit"]').attr('href', secondaryEditHref.replace('=' + imageId, '=primary'));
							$(currentSecondary).find('a[data-action="field-image-multiple-delete"]').attr('href', secondaryDeleteHref.replace('=' + imageId, '=primary'));
							$(currentSecondary)
								.removeClass('field-image-multiple-preview-' + imageId)
								.addClass('field-image-multiple-preview-primary');

							if ($(currentPrimary).length > 0) {
								if (result.secondaryImages != undefined && result.secondaryImages) {
									$.each(result.secondaryImages, function(index, secondaryImage){
										if (secondaryImage.image_id == imageId) {
											$(currentPrimary).find('a[data-action="field-image-multiple-preview"]').attr('href', secondaryImage.imageFileName);
											$(currentPrimary).find('a[data-action="field-image-multiple-edit"]')
												.attr('data-image-id', imageId)
												.attr('data-image-primary', '0')
												.attr('data-image-url', secondaryImage.imageFileName)
												.attr('data-image-alt-text', secondaryImage.altText)
												.attr('data-image-caption', secondaryImage.caption)
												.attr('data-image-priority', secondaryImage.priority);

											$(currentPrimary)
												.removeClass('field-image-multiple-preview-primary')
												.addClass('field-image-multiple-preview-' + imageId);

											$(currentPrimary).find('a[data-action="field-image-multiple-edit"]').attr('href', _secondaryEditHref);
											$(currentPrimary).find('a[data-action="field-image-multiple-delete"]').attr('href', _secondaryDeleteHref);

										}
									});
								}
							}

							AdminForm.displayAlert('Image has been successfully updated', 'success');
						}
					);
				});

				imageEditModal.modal('show');

				return false;
			});

			$('.field-image-multiple a[data-action="field-image-multiple-delete"]').click(function(){
				var self = this;
				AdminForm.confirm('Do you really want to delete the selected image?', function() {
					AdminForm.sendRequest(
						$(self).attr('href'),
						{},
						'Please wait',
						function(data){
							$(self).closest('.field-image-multiple-preview').remove();
							AdminForm.displayAlert('Image has been successfully deleted', 'success');
						}
					);
				});

				return false;
			});

			/**
			 * Image fields
			 */
			$('.field-image input[type="file"]').change(function() {
				var self = this;

				if (self.files != undefined && self.files[0]) {

					var file = self.files[0];

					if (!file || file.name == undefined || file.size == undefined) return;

					var type = '|' + file.type.slice(file.type.lastIndexOf('/') + 1) + '|';

					if ('|jpg|png|jpeg|gif|'.indexOf(type) === -1) {
						alert('Please choose image file!');
						return;
					}

					var canvas = $(self).parent().find('canvas');
					var image = $(self).parent().find('img');
					var deleteLink = $(self).parent().find('a[data-action="field-image-delete"]');
					var reader = new FileReader();

					reader.onload = function(e) {
						var data = e.target.result;
						var dataParts = data.split(',');

						var img = new Image();
						img.onload = function(){
							var width = this.width / (this.height / 100);
							var height = 100; // always 100 pixels
							canvas.attr({ width: width, height: height });
							canvas[0].getContext('2d').drawImage(this, 0, 0, width, height);

							$(image).hide();
							$(deleteLink).hide();
							$(canvas).show();
						};
						img.src = e.target.result;
					};

					reader.readAsDataURL(file);
				}
			});

			$('.field-image a[data-action="field-image-delete"]').click(function(){
				var self = this;
				AdminForm.confirm('Do you really want to delete selected images?', function() {
					AdminForm.sendRequest(
						$(self).attr('href'),
						{},
						'Please wait',
						function(data){
							$(self).closest('.field-image-preview').find('img,.field-image-delete').hide();
							AdminForm.displayAlert('Image has been successfully deleted', 'success');
						}
					);
				});
				return false;
			});

			/**
			 * Address forms with countries and states
			 */
			if (typeof countriesStates !== 'undefined') {
				$('.form-address').each(function(formIndex, form) {
					initAddressForm(form);
				});
			}

			/**
			 * Password
			 */
			if ($('.field-password.meter').length > 0)
			{
				$('.field-password.form-group input[type=password]')
					.change(function(){
						setPasswordMeter(
							$(this).closest('.form-group'),
							getPasswordStrength($(this).val())
						);
					})
					.keyup(function(){
						setPasswordMeter(
							$(this).closest('.form-group'),
							getPasswordStrength($(this).val())
						);
					});
			}

			/**
			 * Recurring fields
			 */
			if ($('.field-recurring-settings').length > 0)
			{
				$('.field-recurring-settings .custom-checkbox').change(function(){
					var id = '#' + $(this).attr('data-field-id');
					var trial = $(this).closest('.field-recurring-settings').hasClass('trial');

					if ($(this).is(':checked'))
					{
						$(id + '-standard-fields').hide();
						$(id + '-custom-fields').show().removeClass('hidden');
					}
					else
					{
						$(id + '-custom-fields').hide();
						$(id + '-standard-fields').show().removeClass('hidden');

						if (trial)
						{
							//alert(1);
							var periodCycles = $(this).closest('.field-recurring-settings').find('.period-cycles');
							$(periodCycles).val('1');
							$(periodCycles).change();
						}
					}
				});

				$('.field-recurring-settings .period-frequency-and-unit')
					.change(function(){
						var trial = $(this).closest('.field-recurring-settings').hasClass('trial');
						var id = '#' + $(this).attr('data-field-id');
						var val = $(this).val();
						var parts = val.split('-');
						$(id + '_period_frequency').val(parts[0]);
						$('.field-recurring-settings .period-frequency[data-field-id="' + $(this).attr('data-field-id') + '"]').val(parts[0]);

						$(id + '_period_unit').val(parts[1]);
						$('.field-recurring-settings .period-unit[data-field-id="' + $(this).attr('data-field-id') + '"]').val(parts[1]);
					});

				$('.field-recurring-settings .period-frequency').change(function(){
					var id = '#' + $(this).attr('data-field-id');
					$(id + '_period_frequency').val($(this).val());

					var periodFrequencyAndUnit = $(this).closest('.field-recurring-settings').find('.period-frequency-and-unit');
					var periodUnit = $(this).closest('.field-recurring-settings').find('.period-unit');

					var newPeriodFrequencyAndUnitValue = $(this).val() + '-' + $(periodUnit).val();
					if ($(periodFrequencyAndUnit).find('option[value="' + newPeriodFrequencyAndUnitValue + '"]').length > 0)
					{
						$(periodFrequencyAndUnit).val(newPeriodFrequencyAndUnitValue);
					}
				});

				$('.field-recurring-settings .period-unit').change(function(){
					var id = '#' + $(this).attr('data-field-id');
					$(id + '_period_unit').val($(this).val());

					var periodFrequencyAndUnit = $(this).closest('.field-recurring-settings').find('.period-frequency-and-unit');
					var periodFrequency = $(this).closest('.field-recurring-settings').find('.period-frequency');

					var newPeriodFrequencyAndUnitValue = $(periodFrequency).val() + '-' + $(this).val();
					if ($(periodFrequencyAndUnit).find('option[value="' + newPeriodFrequencyAndUnitValue + '"]').length > 0)
					{
						$(periodFrequencyAndUnit).val(newPeriodFrequencyAndUnitValue);
					}
				});

				$('.field-recurring-settings .period-cycles').change(function(){
					var id = '#' + $(this).attr('data-field-id');
					$(id + '_period_cycles').val($(this).val());

					$('.field-recurring-settings .period-cycles[data-field-id="' + $(this).attr('data-field-id') + '"]').val($(this).val());
				});
			}
		});
	};

	getPasswordStrength = function(str) {
		if (str == '') return 0;
		var points = 0;
		if (str.length >= 8) points++;
		if (/[a-z]/.test(str) && /[A-Z]/.test(str)) points++;
		if (/\d+/.test(str)) points++;
		if (/.[!,@,#,$,%,^,&,*,?,_,~,-,(,)]/.test(str)) points++;
		if (str.length > 12) points++;

		return points;
	}

	setPasswordMeter = function(selector, strength)
	{
		var titles = ['Too short', 'Very weak', 'Weak', 'Good', 'Strong', 'Very strong']
		var progressBar = $(selector).find('.field-password-meter');

		$(progressBar).css('width', strength * 20 +'%').attr('aria-valuenow', strength * 20);
		$(progressBar).removeClass('progress-bar-warning').removeClass('progress-bar-danger');

		if (strength < 2) $(progressBar).addClass('progress-bar-danger')
		else if (strength < 4) $(progressBar).addClass('progress-bar-warning')
		else $(progressBar).addClass('progress-bar-success');

		$(selector).find('.field-password-strength').html(titles[strength]);
	}

	initCheckbox = function(ele) {
		$(ele).find('label').append('<span class="sprite"></span>');
		var cb = $(ele).find('input[type=checkbox]');
		if (cb.is(':disabled')) {
			$(ele).find('label,.sprite').addClass('not-clickable');
		}

		var toggleCbSprite = function(cbEle, ele) {
			if ($(cbEle).is(':checked')) {
				$(cbEle).siblings('.sprite').addClass('checked');
			} else {
				$(cbEle).siblings('.sprite').removeClass('checked');
			}
		};
		$(ele).find('input[type=checkbox]').change(function() {
			toggleCbSprite(this, ele);
		}).focus(function() {
			$(this).siblings('.sprite').addClass('active');
		}).blur(function() {
			$(this).siblings('.sprite').removeClass('active');
		});
		cb.each(function(idx, cbEle) {
			toggleCbSprite(cbEle, ele);
		});

		var rb = $(ele).find('input[type=radio]');
		rb.change(function() {
			var theForm = $(this).closest('form');
			theForm.find('input[name="'+$(this).attr('name')+'"]').closest('.form-group').find('.sprite').removeClass('checked');
			$(this).siblings('.sprite').addClass('checked');
		}).focus(function() {
			$(this).siblings('.sprite').addClass('active');
		}).blur(function() {
			$(this).siblings('.sprite').removeClass('active');
		});
		rb.filter(':checked').siblings('.sprite').addClass('checked');
	};

	ensureTooltips = function() {
		$('.tooltip-popover').each(function(idx, ele) {
			var parentFormGroup = $(ele).closest('.form-group,th');
			$(ele).popover({
				'animation': true,
				'html': true,
				'placement': 'top',
				'selector': false,
				'trigger': 'manual',
				'title': '',
				'content': parentFormGroup.find('.tooltip').html(),
				'delay': 0,
				'container': false
			}).click(function() {
				$(this).popover('toggle');
			}).mouseenter(function() {
				if ($(this).siblings('.popover:visible').length == 0) {
					$(this).popover('show');
				}
			});

			$(ele).closest('form').find('input,select,textarea,button,a').focus(function() {
				var popoverEle = $('.popover:visible');
				var parentFormGroup = $(this).closest('.form-group,th');
				if (popoverEle.length > 0 && parentFormGroup.find('.popover:visible').length == 0) {
					popoverEle.hide();
				}
				return true;
			});
		});

		$(window).on('blur', function(e) {
			if ($(this).is('input,select,textarea')) {
				var popoverEle = $(this).closest('.form-group,th').find('.popover:visible');
				if (popoverEle.length > 0) {
					popoverEle.siblings('.tooltip-popover').popover('hide');
				}
			}
		});
	};

	initAddressForm = function(form) {
		var countryInput = $(form).find('.input-address-country');
		var stateInput = $(form).find('.input-address-state');
		var provinceInput = $(form).find('.input-address-province');

		// 21.05.2014 Suflihim
		countryInput.empty();
		if ( countryInput.hasClass("all-countries-value") ){
			$(countryInput).append('<option value="0">All Countries</option>');
		}
		// 21.05.2014 Suflihim end

		$.each(countriesStates, function(countryIndex, country){
			$(countryInput).append('<option value="' + country.id + '">' + country.name + '</option>');
		});

		$(countryInput)
			.val($(countryInput).attr('data-value'))
			.change(function(){
				var countryId = $(this).val();
				// 21.05.2014 Suflihim
				// Hide "states fields group" on "all countries"
				if ( countryId == 0 )
				{
				  $(stateInput)
					.attr('disabled', 'disabled')
					.closest('.form-group').hide();
				}
				else{
					$.each(countriesStates, function(countryIndex, country){
						if (country.id == countryId)
						{
							if (country.states)
							{
								$(stateInput).html('');

								// 21.05.2014 Suflihim
								if ( stateInput.hasClass("all-states-value") ){
									$(stateInput).append('<option value="0">All States</option>');
								}
								// 21.05.2014 Suflihim end

								$.each(country.states, function(stateIndex, state){
									$(stateInput).append('<option value="' + state.id + '">' + state.name + '</option>');
								});

								stateInput.find('option[value="'+$(stateInput).attr('data-value')+'"]').prop('selected', 'selected');
								$(provinceInput)
									.attr('disabled', 'disabled')
									.closest('.form-group').hide();
								$(stateInput)
									.removeAttr('disabled')
									.closest('.form-group').removeClass('hidden').show();
							}
							else
							{
								$(stateInput)
									.attr('disabled', 'disabled')
									.closest('.form-group').hide();
								$(provinceInput)
									.removeAttr('disabled')
									.closest('.form-group').removeClass('hidden').show();
							}
						}
					});
				}
				// 21.05.2014 Suflihim end
			})
			.change();
	};

	init();

	return {
		init: init,
		ensureTooltips: ensureTooltips,
		initAddressForm: initAddressForm,
		initCheckbox: initCheckbox
	};
}());
