var Products = (function($) {
	var init, productsUpdateSeoUrl, removeProduct;

	init = function() {
		$(document).ready(function() {
			$('.remove-test-products').click(function() {
				var nonce = $(this).attr('data-nonce');
				AdminForm.confirm(
					trans.products.confirm_remove_test_products,
					function() {
						document.location = 'admin.php?p=product&mode=delete&deleteMode=test-products&nonce=' + nonce;
					}
				);

				return false;
			});

			$('#modal-products-export').on('show.bs.modal', function() {
				$(this).find('input[type=checkbox]:checked').prop('checked', false).change();
				$(this).find('.sprite.checked').removeClass('checked');
			});

			$('#modal-products-export-check-all').on('click', function() {
				$('#modal-products-export').find('input[type=checkbox]').prop('checked', true).change();
				$('#modal-products-export').find('.sprite').addClass('checked');
			});

			$('#modal-products-export-uncheck-all').on('click', function() {
				$('#modal-products-export').find('input[type=checkbox]:checked').prop('checked', false).change();
				$('#modal-products-export').find('.sprite.checked').removeClass('checked');
			});

			$('form[name="form-products-export"]').submit(function() {
				var theForm = $(this);
				var theModal = theForm.closest('.modal');
				var exportMode = $('input[name="form-products-export-mode"]:checked').val();
				var nonce = theForm.find('input[name="nonce"]').val();

				var fields = '';
				theForm.find('input[type=checkbox]:checked').each(function() {
					fields = fields + (fields == '' ? '' : ',') + $(this).attr('value');
				});

				if (exportMode == 'selected') {
					var ids = '';
					$('.checkbox-product:checked').each(function() {
						var id = $(this).val();
						ids += (ids == '' ? '' : ',') + id;
					});

					if (ids != '') {
						url = 'admin.php?p=product&mode=export&exportMode=selected&fields=' + fields + '&ids=' + ids + '&nonce=' + nonce;
						$('#export-iframe').attr('src', url);
						theModal.modal('hide');
					}
					else {
						AdminForm.displayModalAlert(theModal, trans.products.no_products_selected_export, 'danger');
					}
				}
				else if (exportMode == 'all') {
					url = 'admin.php?p=product&mode=export&exportMode=all&fields=' + fields + '&nonce=' + nonce;
					$('#export-iframe').attr('src', url);
					theModal.modal('hide');
				}

				return false;
			});

			$('form[name="form-products-delete"]').submit(function() {
				var theForm = $(this);
				var theModal = theForm.closest('.modal');
				var deleteMode = $('input[name="form-products-delete-mode"]:checked').val();
				var nonce = theForm.find('input[name="nonce"]').val();

				if (deleteMode == 'selected') {
					var ids = '';
					$('.checkbox-product:checked').each(function() {
						var id = $(this).val();
						ids += (ids == '' ? '' : ',') + id;
					});
					if (ids != '') {
						window.location='admin.php?p=product&mode=delete&deleteMode=selected&ids=' + ids + '&nonce=' + nonce;
					} else {
						AdminForm.displayModalAlert(theModal, trans.products.no_products_selected_delete, 'danger');
					}
				}
				else if (deleteMode == 'search') {
					window.location='admin.php?p=product&mode=delete&deleteMode=search&nonce=' + nonce;
				}

				return false;
			});

			$('#field-title,#field-product_id')
				.keyup(function(){ productsUpdateSeoUrl(); })
				.change(function(){ productsUpdateSeoUrl(); });

			/**
			 * Product type changes
			 */
			$('#field-product_type').change(function() {
				var type = $(this).val();
				$('#group-digital').toggle(type == 'Digital');
				$('#field-weight,#field-dimension-width,#field-free_shipping,#field-products_location_id').closest('.form-group').toggle(type == 'Tangible');
				$('#field-digital_product_file,#field-digital_product_file_upload').closest('.form-group').toggle(type == 'Digital');

				$('#field-same_day_delivery').closest('.form-group').toggle(type == 'Tangible');
				$('#radio_field-recurring_billing_data-auto_complete_options-_auto_complete_initial_order').closest('.form-group').toggle(type != 'Tangible');

			}).change();

			/**
			 * Inventory settings changes
			 */
			$('input[name="inventory_control"]').change(function() {
				var val = $('input[name="inventory_control"]:checked').val();
				$('#field-stock, #field-stock_warning').closest('.form-group').toggle(val=='Yes');
				$('#field-inventory_rule').closest('.form-group').toggle(val!='No');

				if (typeof(ProductVariants) !== 'undefined')
					ProductVariants.renderProductVariantsTable(productVariants == undefined ? [] : productVariants);

			});

			$('input[name="inventory_control"]:first').change();

			$('.delete-product').click(function() {
				var id = $(this).attr('data-id');
				var nonce = $(this).attr('data-nonce');

				return removeProduct(id, nonce);
			});
		});
	};

	productsUpdateSeoUrl = function() {
		if (productsSeoUrlSettings != undefined) {
			var url = productsSeoUrlSettings.template
				// TODO: add %CategoryKey%, %CategoryName%, %CategoryDbId%, %CategoryPath%, %CategoryURL%
				.replace('%ProductName%', $('#field-title').val().replace(/[^\w\/]|_/g, ' ').trim())
				.replace('%ProductId%', $('#field-product_id').val().replace(/[^\w\/]|_/g, ' ').trim())
				.replace('%ProductDbId%', '[id]')
				.replace('%CategoryKey%', '[category-key]')
				.replace('%CategoryName%', '[category-name]')
				.replace('%CategoryDbId%', '[category-id]')
				.replace('%CategoryPath%', '[category-path]')
				.replace('%CategoryURL%', '[category-url]')
				.trim()
				.replace(/\s+/g, productsSeoUrlSettings.joiner);

			if (productsSeoUrlSettings.lowercase) url = url.toLocaleLowerCase();
			$('#field-url_custom').attr('placeholder', url);
		}
	};

	removeProduct = function(id, nonce) {
		AdminForm.confirm(trans.products.confirm_remove, function() {
			window.location = 'admin.php?p=product&mode=delete&deleteMode=single&id=' + id + '&nonce=' + nonce;
		});

		return false;
	};

	init();

}(jQuery));
