var GlobalAttributes = (function($) {
	var init, setFields;

	init = function() {
		$(document).ready(function(){
			// delete attributes
			$('[data-action="action-globalattributes-delete"]').click(function(){

				var deleteMode = $('input[name="form-globalattributes-delete-mode"]:checked').val();

				if (deleteMode == 'selected')
				{
					var ids = '';
					$('.checkbox-globalattributes:checked').each(function(){
						var id = $(this).val();
						ids += (ids == '' ? '' : ',') + id;
					});

					if (ids != '')
					{
						window.location='admin.php?p=products_attribute&mode=delete&deleteMode=selected&ids=' + ids + '&nonce=' +  $(this).attr('nonce');
					}
					else
					{
						alert('Please select at least one attribute to delete');
					}
				}
				else if (deleteMode == 'all')
				{
					window.location='admin.php?p=products_attribute&mode=delete&deleteMode=all' + '&nonce=' + $(this).attr('nonce');
				}
			});

			// check attribute type change
			setFields();
			$('#field-attribute_type').change(function(){
				setFields();
			});

			// handle form errors
			$('form[name=form-globalproductattribute]').submit(function() {
				var errors = [];
				if ($.trim($('#field-name').val()) == '') {
					errors.push({field: '#field-name', message: 'Please enter attribute name'});
				}

				if ($.trim($('#field-caption').val()) == '') {
					errors.push({field: '#field-caption', message: 'Please enter attribute title'});
				}

				if ($('#field-categories- option:selected').length == 0) {
					errors.push({field: '#field-categories-', message: 'Please choose at least one category'});
				}

				var $field_type = $("#field-attribute_type").val();

				switch ($field_type) {
					case 'text':
					case 'textarea': {
						if ($.trim($('#field-text_length').val()) == '') {
							errors.push({field: '#field-text_length', message: 'Please enter text length'});
						} else if (parseInt($.trim($('#field-text_length').val())) <= 0) {
							errors.push({field: '#field-text_length', message: 'Text length must be greater than zero'});
						}

						break;
					}
					case 'select':
					case 'radio': {
						if ($.trim($(".field-options").val()) == '') {
							errors.push({
								field: '.field-options',
								message: 'Please enter attribute options'
							});
						}

						break;
					}
				}

				AdminForm.displayErrors(errors);
				return errors.length == 0;
			});
		});
	};

	setFields = function(){
		var attributeType = $("#field-attribute_type").val();
		var optionsEnabled = attributeType == 'select' || attributeType == 'radio';
		var textEnabled = !optionsEnabled;

		$('#field-text_length').closest('.form-group').toggleClass('required', textEnabled).toggle(textEnabled);
		$('#field-options').closest('.form-group').toggleClass('required', optionsEnabled).toggle(optionsEnabled);
		$('#field-track_inventory').closest('.form-group').toggle(optionsEnabled);
	};

	init();

}(jQuery));


function removeGlobalAttribute(id, nonce) {
    AdminForm.confirm('Are you sure you wish to remove this global attribute?', function() {
        window.location = 'admin.php?p=products_attribute&mode=delete&deleteMode=single&id=' + id + '&nonce=' + nonce;
    });

    return false;
}