$(document).ready(function(){
	$('form[name=form-settings]').submit(function() {
		var theForm = $(this);
		var theModal = theForm.closest('.modal');

		AdminForm.sendRequest(
			theForm.attr('action'),
			theForm.serialize(), null,
			function(data) {
				if (data.status == 1) {
					AdminForm.hideSpinner();
					theModal.modal('hide');
					AdminForm.clearAlerts();
					AdminForm.displayAlert('Success!');
				} else {
					if (data.errors != undefined) {
						AdminForm.displayModalErrors(theModal, errors);
					} else if (data.message != undefined) {
						AdminForm.displayModalAlert(theModal, data.message, 'danger');
					}
				}
			}
		);

		return false;
	});

	$('form[name=form-promo-code]').submit(function() {
		var errors = [];
		if ($.trim($('#field-name').val()) == '') {
			errors.push({
				field: '#field-name',
				message: 'Please enter Name'
			});
		}
		
		if ($.trim($('#field-promo_code').val()) == '') {
			errors.push({
				field: '#field-promo_code',
				message: 'Please enter Promo Code'
			});
		}
		
		if ($.trim($('#field-discount').val()) == '') {
			errors.push({
				field: '#field-discount',
				message: 'Please enter Discount'
			});
		} else if ($.trim($('#field-discount').val()) != '' && $.trim($('#field-discount').val()) <= 0) {
			errors.push({
				field: '#field-discount',
				message: 'Discount must be numeric'
			});
		}
		
		if ($.trim($('#field-min_amount').val()) == '') {
			errors.push({
				field: '#field-min_amount',
				message: 'Please enter Minimum Order Subtotal'
			});
		} else if ($.trim($('#field-min_amount').val()) != '' && $.trim($('#field-min_amount').val()) < 0) {
			errors.push({
				field: '#field-min_amount',
				message: 'Minimum Order Subtotal must be numeric and greater or equal to zero'
			});
		}
	
		AdminForm.displayErrors(errors);
		return errors.length == 0;
	});
	
	/** 
	 * Handle delete button
	 */
	$('[data-action="action-promo-codes-delete"]').click(function(){

		var deleteMode = $('input[name="form-promo-codes-delete-mode"]:checked').val();
		if (deleteMode == 'selected')
		{
			var ids = '';
			$('.checkbox-promo-code:checked').each(function(){
				var id = $(this).val();
				ids += (ids == '' ? '' : ',') + id;
			});
			if (ids != '')
			{
				window.location='admin.php?p=promotions&mode=delete&deleteMode=selected&ids=' + ids + '&nonce=' +  $(this).attr('nonce');
			}
			else
			{
				alert('Please select at least one promo code');
			}
		}
		else if (deleteMode == 'search')
		{
			window.location='admin.php?p=promotions&mode=delete&deleteMode=search' + '&nonce=' + $(this).attr('nonce');
		}
	});
	
	
	
	
	// Manage product group and categories for promo codes
	$("#field-categories").change(function(){
		UpdateAvailableProducts();
	});

	$('#field-categories').change();
        UpdateAssignedProductsList();

        $('#btnAddProduct').click(function(){
        	
			$("#btnAddProduct").attr("disabled", "disabled");
			$("#btnRemoveProduct").attr("disabled", "disabled");
			var promo_id = $("#promo_id").val();
			var selectedProducts = [];
			$('#field-products :selected').each(function(i, selectedOption){
				selectedProducts[i] = $(selectedOption).val();
			});

			var selectedPromoCategories = [];
			$('#field-promo_categories- :selected').each(function(i, selectedOption){
				selectedPromoCategories[i] = $(selectedOption).val();
			});
	
			$.getJSON("admin.php?p=promotions&mode=assignProducts&promo_id=" + escape(promo_id) + '&products=' + escape(selectedProducts) + '&promo_categories=' + escape(selectedPromoCategories), 
				function(data){
					if (data.result)
					{
						UpdateAssignedProductsList();
						UpdateAvailableProducts();
					}
					$("#btnAddProduct").removeAttr("disabled");
					$("#btnRemoveProduct").removeAttr("disabled");
				});
			
			return false;
        });

        $('#btnRemoveProduct').click(function(){
			$("#btnAddProduct").attr("disabled", "disabled");
			$("#btnRemoveProduct").attr("disabled", "disabled");		
			var promo_id = $("#promo_id").val();
			var selectedProducts = [];
			$('#field-selectedProducts :selected').each(function(i, selectedOption){
				selectedProducts[i] = $(selectedOption).val();
			});

			var selectedPromoCategories = [];
			$('#field-promo_categories- :selected').each(function(i, selectedOption){
				selectedPromoCategories[i] = $(selectedOption).val();
			});

			$.getJSON("admin.php?p=promotions&mode=unassignProducts&promo_id=" + escape(promo_id) + '&products=' + escape(selectedProducts) + '&promo_categories=' + escape(selectedPromoCategories), 
			function(data){
				if (data.result)
				{
					UpdateAssignedProductsList();
					UpdateAvailableProducts();
				}
				$("#btnAddProduct").removeAttr("disabled");
				$("#btnRemoveProduct").removeAttr("disabled");
			});
			return false;		
        });
              
	function UpdateAvailableProducts()
	{
		var promo_id = $("#promo_id").val();
		var selectedCategories = [];
		$('#field-categories :selected').each(function(i, selectedOption){
			selectedCategories[i] = $(selectedOption).val();
		});
		$.getJSON("admin.php?p=promotions&promo_id="+promo_id+"&mode=getProducts&categories=" + escape(selectedCategories), function(data){
			$("#field-products").html("");
			$(data.products).each(function(i, product){
				var o = $("<option></option>").val(product.pid).html(product.title);
				$("#field-products").append(o);
			});                        
		});
		return false;
	}

	function UpdateAssignedProductsList()
	{
		var promo_id = $("#promo_id").val();
		$.getJSON("admin.php?p=promotions&mode=getAssignedProducts&promo_id=" + escape(promo_id), function(data){
			$("#field-selectedProducts").html("");
			$(data.products).each(function(i, product){
				var o = $("<option></option>").val(product.pid).html(product.title);
				$("#field-selectedProducts").append(o);
			});
		});
	}

	checkPromoType();	
	$("#field-promo_type").change(function () {
		checkPromoType();
	});

});


function checkPromoType() {
	if ($("#field-promo_type").val() == "Product") {
		$("#products-body").parent().show();
		$("#selected_products-body").parent().show();
		$("#field-selectedProducts").parent().show();
		$("#buttons-body").parent().show();
		$("#categories-body").parent().show();
	}
	else {
		$("#products-body").parent().hide();
		$("#selected_products-body").parent().hide();
		$("#field-selectedProducts").parent().hide();
		$("#buttons-body").parent().hide();
		$("#categories-body").parent().hide();
	}
}

function removePromoCode(id, nonce) {
	AdminForm.confirm('Are you sure you wish to remove this promo code?', function() {
		window.location = 'admin.php?p=promotions&mode=delete&deleteMode=single&id=' + id + '&nonce=' + nonce;
	});

	return false;
}