var QuickStart = (function($) {
	var init;

	init = function() {
		$('#form-qsg-company-info').submit(function(){
			var theForm = this;

			$(theForm).find('.has-error').removeClass('has-error');

			var companyName = $('#qsg_company_name');
			if (companyName.length > 0 && $.trim(companyName.val()) == '') {
				$('#qsg_company_name').closest('.form-group').addClass('has-error');
			}

			if ($.trim($('#qsg_company_address1').val()) == '') {
				$('#qsg_company_address1').closest('.form-group').addClass('has-error');
			}

			if ($.trim($('#qsg_company_city').val()) == '') {
				$('#qsg_company_city').closest('.form-group').addClass('has-error');
			}

			if ($('#qsg_company_state').closest('.form-group').is(':visible')) {
				if ($.trim($('#qsg_company_state').val()) == '') {
					$('#qsg_company_state').closest('.form-group').addClass('has-error');
				}
			} else {
				if ($.trim($('#qsg_company_province').val()) == '') {
					$('#qsg_company_province').closest('.form-group').addClass('has-error');
				}
			}

			if ($.trim($('#qsg_company_country').val()) == '') {
				$('#qsg_company_country').closest('.form-group').addClass('has-error');
			}

			if ($.trim($('#qsg_company_zip').val()) == '') {
				$('#qsg_company_zip').closest('.form-group').addClass('has-error');
			}

			if ($.trim($('#qsg_company_phone').val()) == '') {
				$('#qsg_company_phone').closest('.form-group').addClass('has-error');
			}

			if ($.trim($('#qsg_security_question_id').val()) == '') {
				$('#qsg_security_question_id').closest('.form-group').addClass('has-error');
			}

			if ($.trim($('#qsg_security_question_answer').val()) == '') {
				$('#qsg_security_question_answer').closest('.form-group').addClass('has-error');
			}

			if ($(theForm).find('.has-error').length > 0) {
				AdminForm.displayAlert('Please fix errors', 'danger');
				$(theForm).find('.has-error .form-control:first').focus();

				//return false;
			}

			AdminForm.sendRequest(
				'admin.php',
				$(theForm).serialize(),
				'Saving data',
				function(data) {
					if (data.status) {
						document.location = $(theForm).attr('action');
					} else {
						var errors = [];
						$.each(data.errors, function(key, value) {
							$.each(value, function(idx, message) {
								errors.push({field: 'input[name="' + key + '"]', message: message});
							});
						});

						AdminForm.displayErrors(errors);
					}
				}
			)

			return false;
		});

		$(document).ready(function() {
			$('.add-test-products').click(function() {
				AdminForm.sendRequest(
					'admin.php?p=product&mode=add-test-products',
					null, null,
					function(data) {
						if (data.status == 1) {
							document.location = 'admin.php?p=payment_methods&qsg_set_step=payments'
						}
					}
				);

				return false;
			});

			$('.quick-start-got-it').click(function() {
				$('#quick-start-backdrop,#quick-start-hidden-msg').hide();
				return false;
			});

			$('#quick-start-banner').click(function() {
				document.location =  $('#quick-start-banner').attr('data-link');
			});
		});

		if ($('#form-qsg-company-info').length == 0) {
			$('#quick-start-backdrop,#main-nav,#header').click(function(e) {
				if ($(e.target).is('.dropdown-toggle') || $(e.target).is('.admin-my-account') || $(e.target).is('[target]')) return true;

				if ($('#quick-start-wrapper').is(':visible')) {
					var newLocation = document.location + '';

					var theLink = $(e.target).closest('a');
					if (theLink.length > 0) {
						newLocation = theLink.attr('href');
					}

					//TODO: optimize this
					newLocation = newLocation.replace('&qsg_set_step=welcome', '');
					newLocation = newLocation.replace('?qsg_set_step=welcome', '?');
					newLocation = newLocation.replace('&qsg_set_step=products', '');
					newLocation = newLocation.replace('?qsg_set_step=products', '?');
					newLocation = newLocation.replace('&qsg_set_step=payments', '');
					newLocation = newLocation.replace('?qsg_set_step=payments', '?');
					newLocation = newLocation.replace('&qsg_set_step=shipping', '');
					newLocation = newLocation.replace('?qsg_set_step=shipping', '?');
					newLocation = newLocation.replace('&qsg_set_step=open', '');
					newLocation = newLocation.replace('?qsg_set_step=open', '?');
					newLocation = newLocation.replace('&qsg_hide=1', '');
					newLocation = newLocation.replace('?qsg_hide=1', '');
					newLocation = newLocation + (newLocation.indexOf('?') > 0 ? '&' : '?') + 'qsg_hide=1';
					document.location = newLocation;

					return false;
				}

				return true;
			});
		} else {
			$('.qsg-menu-item').click(function(){
				return false;
			});
		}

		var handleActivatePaymentMethodChange = function() {
			var hasAnyChecked = $('.activate-payment-method-qs:checked').length > 0;
			var setupButton = $('.btn-setup-shipping');
			setupButton.prop('disabled', !hasAnyChecked);
			if (hasAnyChecked) {
				setupButton.removeAttr('disabled');
			} else {
				setupButton.attr('disabled', 'disabled');
			}
			return true;
		};

		$('.activate-payment-method-qs').change(function() {
			handleActivatePaymentMethodChange();
		});

		handleActivatePaymentMethodChange();

		$('form[name=payment-auto-board]').submit(function() {
			var theForm = $(this);
			AdminForm.sendRequest(
				'admin.php?p=payment_method&action=auto-board',
				theForm.serialize(), null,
				function(data) {
					if (data.status == 1 && data.activeCount > 0) {
						document.location = 'admin.php?p=shipping&qsg_set_step=shipping';
					} else {
						if (data.message !== undefined) {
							if (data.message == 'stripe.account_exists') {
								$('#modal-stripe-connect').modal('show');
							} else {
								AdminForm.displayAlert(data.message, 'danger');
							}
						}
					}
				}
			);

			return false;
		});

		$('form[name=form-stripe-connect]').submit(function() {
			var theForm = $(this);
			var theModal = theForm.closest('.modal');

			AdminForm.sendRequest(
				'admin.php?p=payment_method&action=auto-board-stripe',
				theForm.serialize(), null,
				function(data) {
					if (data.status == 1 && data.activeCount > 0) {
						document.location = 'admin.php?p=shipping&qsg_set_step=shipping';
					} else {
						if (data.message !== undefined) {
							if (data.message == 'stripe.account_exists') {
								AdminForm.displayModalAlert(theModal, 'An account with this email address already exists', 'danger');
							} else {
								AdminForm.displayModalAlert(theModal, data.message, 'danger');
							}
						}
					}
				}
			);

			return false;
		});

		$('.btn-setup-shipping').click(function() {
			$('form[name=payment-auto-board]').submit();
			return false;
		});
	};

	init();

}(jQuery));