(function($) {
	var init;

	init = function() {
		$(document).ready(function() {
			$('#modal-company-shipping-address').on('show.bs.modal', function() {
				var theForm = $('#form-company-shipping-address');
				theForm.get(0).reset();

				forms.initAddressForm(theForm);
			});

			$('#form-company-shipping-address').submit(function() {
				var theForm = $(this);
				var theModal = theForm.closest('.modal');

				var errors = [];
				if ($.trim($('#field-ShippingOriginAddressLine1').val()) == '') {
					errors.push({
						field: '#field-ShippingOriginAddressLine1',
						message: 'Please enter a street address'
					});
				}
				if ($.trim($('#field-ShippingOriginCity').val()) == '') {
					errors.push({
						field: '#field-ShippingOriginCity',
						message: 'Please enter a city'
					});
				}
				var provinceField = $('#field-ShippingOriginProvince');
				if (provinceField.closest('.form-group').is(':visible') && $.trim(provinceField.val()) == '') {
					errors.push({
						field: '#field-ShippingOriginProvince',
						message: 'Please enter a province'
					});
				}
				if ($.trim($('#field-ShippingOriginZip').val()) == '') {
					errors.push({
						field: '#field-ShippingOriginZip',
						message: 'Please enter a zip / postal code'
					});
				}

				if (errors.length > 0) {
					AdminForm.displayModalErrors(theModal, errors);
					return false;
				}

				return true;
			});
		});
	};

	init();
}(jQuery));