$(document).ready(function(){
	$('form[name=form-textpage]').submit(function() {
		var errors = [];
		if ($.trim($('#field-title').val()) == '') {
			errors.push({
				field: '#field-title',
				message: 'Please enter title'
			});
		}
		AdminForm.displayErrors(errors);

		return errors.length == 0;
	});

	/**
	 * Handle delete button
	 */
	$('[data-action="action-pages-delete"]').click(function(){

		var deleteMode = $('input[name="form-textpages-delete-mode"]:checked').val();

		if (deleteMode == 'selected')
		{
			var ids = '';
			$('.checkbox-textpage:checked').each(function(){
				var id = $(this).val();
				ids += (ids == '' ? '' : ',') + id;
			});
			if (ids != '')
			{
				window.location='admin.php?p=page&mode=delete&deleteMode=selected&ids=' + ids + '&nonce=' +  $(this).attr('nonce');
			}
			else
			{
				alert('Please select at least one page to delete');
			}
		}
		else if (deleteMode == 'search')
		{
			window.location='admin.php?p=page&mode=delete&deleteMode=search' + '&nonce=' + $(this).attr('nonce');
		}
	});

	/**
	 * Handle title & id changes
	 */
	function pagesUpdateSeoUrl() {
		if (PagesSeoUrlSettings != undefined) {

			var url = PagesSeoUrlSettings.template
				.replace('%PageName%', $('#field-title').val().replace(/[^\w\/]|_/g, ' ').trim())
				.trim()
				.replace(/\s+/g, PagesSeoUrlSettings.joiner);

			if (PagesSeoUrlSettings.lowercase) url = url.toLocaleLowerCase();
			$('#field-url_custom').attr('placeholder', url);
		}
	}

	$('#field-title')
		.keyup(function(){pagesUpdateSeoUrl();})
		.change(function(){pagesUpdateSeoUrl();});
});

function removeTextPage(id, nonce) {
	AdminForm.confirm('Are you sure you wish to remove this site page?', function() {
		window.location = 'admin.php?p=page&mode=delete&deleteMode=single&id=' + id + '&nonce=' + nonce;
	});

	return false;
}