var trans = {
	'admins': {
		'confirm_remove': 'Are you sure you wish to remove this administrator?',
		'name_required': 'Please enter first & last name',
		'email_required': 'Please enter email',
		'username_required': 'Please enter username',
		'password_required': 'Please enter password',
		'password_confirmation_mismatch': 'Password and confirmation are not equal',
		'password_invalid': 'Password is too short.  Minimum length is 8 characters',
		'rights_invalid': 'Please choose at least one privilege!',
		'no_admins_selected': 'Please select at least one administrator to delete'
	},
	'api': {
		'username_required': 'Please enter username',
		'password_required': 'Please enter password',
		'token_required': 'Please either generate or enter a security token'
	},
	'apps': {
		'confirm_disable': 'Are you sure you wish to disable {title}?'
	},
	'backup': {
		'confirm_create_backup': 'Are you sure you wish to create a backup?',
		'confirm_delete_backup': 'Are you sure you wish to delete this backup?',
		'confirm_restore_backup': 'Are you sure you wish to restore this backup?'
	},
	'categories': {
		'no_categories_selected_export': 'Please select at least one category to export',
		'no_categories_selected': 'Please select at least one category to delete',
		'confirm_remove': 'Are you sure you wish to remove this category?'
	},
	'common': {
		'success': 'Success!',
		'updating': 'Updating'
	},
	'countries': {
		'no_countries_selected': 'Please select at least one country to delete',
		'confirm_remove': 'Are you sure you wish to remove this country?'
	},
	'credit_card_storage': {
		'username_required': 'Please enter username',
		'password_required': 'Please enter password',
		'password2_required': 'Please enter password confirmation',
		'password2_must_match': 'Password and password confirmation must match',
		'country_required': 'Please select a country',
		'province_required': 'Please enter a province',
		'city_required': 'Please enter a city',
		'company_name_required': 'Please enter an organization name',
		'company_unit_name_required': 'Please enter an organization unit name',
		'common_name_required': 'Please enter a common name',
		'email_required': 'Please enter email'
	},
	'currencies': {
		'no_currencies_selected': 'Please select at least one currency to delete',
		'no_currencies_selected_update': 'Please select at least one currency to update'
	},
	'doba': {
		'send_order': 'Are you sure you wish to send this order to Doba?'
	},
	'endicia': {
		'pic_number_required': 'Please enter a PIC number',
		'addfunds_passphrase_required': 'Please enter your Endicia passphrase',
		'addfunds_amount_required': 'Please enter the amount of funds to add',
		'current_passphrase_required': 'Please enter your current passphrase',
		'new_passphrase_required': 'Please enter a new Endicia passphrase',
		'confirm_new_passphrase_required': 'Please enter a new confirm passphrase',
		'confirm_new_passphrase_not_match': 'Your new passphrase and confirm passphrase do not match'
	},
	'form_fields': {
		'name_required': 'Please enter field name',
		'caption_required': 'Please enter field caption'
	},
	'import': {
		'assign_required_fields': 'Please assign required fields'
	},
	'orders': {
		'no_orders_selected_print': 'Please select at least one order to print',
		'no_orders_selected_export': 'Please select at least one order to export',
		'no_orders_selected_update': 'Please select at least one order to update',
		'no_orders_selected_delete': 'Please select at least one order to delete',
		'no_orders_selected_fulfill': 'Please select at least one order to fulfill',
		'invalid_number': 'Please enter a valid number',
		'return_items': 'Are you sure you wish to return all items to inventory?',
		'no_items_fulfill': 'No line items selected for fulfillment',
		'title_required': 'Please enter title',
		'note_required': 'Please enter note',
		'confirm_remove': 'Are you sure you wish to remove this order?'
	},
	'payment_methods': {
		'title_required': 'Please enter a title',
		'confirm_remove_payment': 'Are you sure you wish to disable this payment?'
	},
	'products': {
		'no_products_selected_export': 'Please select at least one product to export',
		'no_products_selected_delete': 'Please select at least one product to delete',
		'confirm_remove': 'Are you sure you wish to remove this product?',
		'confirm_remove_test_products': 'Are you sure you wish to delete the sample products?',
		'confirm_add_test_products': 'Do you wish to add the sample products for this theme?'
	},
	'products_attributes': {
		'confirm_remove': 'Are you sure you wish to delete the selected attribute?',
		'choose_global_attribute': 'Please choose at least one global attribute'
	},
	'products_promotions': {
		'confirm_remove': 'Are you sure you wish to delete the selected product promotion?'
	},
	'stamps': {
		'amount_required': 'Please enter a purchase amount',
		'confirm_carrier_pickup': 'Are you sure that you want to request a carrier pickup?'
	},
	'states': {
		'no_states_selected': 'Please select at least one state / province to delete',
		'confirm_remove': 'Are you sure you wish to remove this state / province?'
	},
	'testimonials': {
		'name_required': 'Please enter name',
		'no_testimonials_selected': 'Please select at least one testimonial'
	}
};
