<?php
function smarty_function_custom_field($params, &$smarty)
{
	extract($params);
	
	if (!isset($field))
	{
		view()->trigger_error("custom_field: field param missed");
		return;
	}
	extract($field);
	$ctrl = "";
	switch ($field_type)
	{
		case "text" : $ctrl = '<input id="cf'.$field_id.'" class="custom-field" type="text" name="custom_field['.$field_id.']" maxlength='.$text_length.' value="'.htmlspecialchars($value).'">'; break;
		case "checkbox" : $ctrl = '<input id="cf'.$field_id.'" class="custom-field" type="checkbox" name="custom_field['.$field_id.']" value="'.$value_checked.'" '.($value == $value_checked ? "checked" : "").'>'; break;
		case "textarea" : $ctrl = '<textarea id="cf'.$field_id.'" class="custom-field" name="custom_field['.$field_id.']" class="small">'.htmlspecialchars($value).'</textarea>'; break;
		case "select" : 
		{
			$ctrl = '<select id="cf'.$field_id.'" class="custom-field" name="custom_field['.$field_id.']">';
			for ($i=0; $i<count($parsed_options); $i++)
			{
				$option = $parsed_options[$i];
				$ctrl .= '<option value="'.$i.'" '.($value == $i ? "selected" : "").'>'.htmlspecialchars(trim($option)).'</option>';
			}
			$ctrl .= '</select>';
			break;
		}
		case "radio" : 
		{
			$value = $value == "" ? "0" : $value;
			for ($i=0; $i<count($parsed_options); $i++)
			{
				$option = $parsed_options[$i];
				$ctrl .= '<input class="custom-field" type="radio" name="custom_field['.$field_id.']" value="'.$i.'" '.(intval($value) == $i ? "checked" : "").' id="cf_'.$field_id.'_'.$i.'">&nbsp;';
				$ctrl .= htmlspecialchars(trim($option)).'<br/>';
			}
			break;
		}
	}
	if (!($field_type == "radio"))
	{
		$req = $is_required == 1 ? "yes" : "no";
	}
	else
	{
		$req = "no";
	}
	$ctrl .= '<input type="hidden" name="custom_field_required['.$field_id.']" value="'.$req.'"/>';
	$ctrl .= '<input type="hidden" name="custom_field_name['.$field_id.']" value="'.htmlentities($field_name, ENT_COMPAT).'"/>';
	$ctrl .= '<input type="hidden" name="custom_field_place['.$field_id.']" value="'.$field_place.'"/>';
	
	return $ctrl;
}
